
#include "RobboLito.h"
#include "RobboTotalBase.h"

#ifdef WINDOWS
int STAT (char *filename)
{
  return 1;
}
#else
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
int STAT (char *filename)
{
  struct stat buf[1];
  return stat (filename, buf);
}
#endif

#define WINDOWS_PREFISSO "icomp."
static void add_nome_total (char* NOME, char *DIRECTORY)
{
  int n = strlen (COMPRESSA_PREFISSO);
#if 0
  if (!memcmp (NOME, "BLOCKINDEX", 10)
      BlockIndexRegister (NOME, DIRECTORY);
#endif
  if (memcmp (NOME, COMPRESSA_PREFISSO, n) && memcmp (NOME, WINDOWS_PREFISSO, n))
    return;
  RobboTotal_registro (NOME + n, DIRECTORY);
}

#ifdef WINDOWS /* HACK */
void GetTotalBase (char* A)
{
  char B[1024];
  WIN32_FIND_DATA ffd;
  HANDLE hFind = INVALID_HANDLE_VALUE;

  SEND ("info string Reading directory %s\n", A);
  strcpy (B, A);
  strcat (B, "\\*");
  hFind = FindFirstFile (B, &ffd);
  if (hFind == INVALID_HANDLE_VALUE)
    {
      SEND ("info string Directory %s not found\n", A);
      return;
    }
  do
    {
      if (!(ffd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) /* recurse ? */
	add_nome_total (ffd.cFileName, A);
    }
  while (FindNextFile (hFind, &ffd));
  FindClose (hFind);
}
#else
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
void GetTotalBase (char* A)
{
  DIR *dir;
  struct dirent *DE;
  SEND ("info string Reading directory %s\n", A);
  dir = opendir (A);
  if (!dir)
    {
      SEND ("info string Directory %s not found\n", A);
      return;
    }
  while ((DE = readdir (dir)))
    add_nome_total (DE->d_name, A);
  closedir (dir);
}
#endif
