
static INLINE void MakeNull (typePOS* POSITION)
{
  TRACE (TRACE_MAKE_UNMAKE,
         printf ("M%cN %d\n", POSITION->wtm ? 'w' : 'b', HEIGHT(POSITION)));
  POSITION->nodes++;
  POSITION->DYN->SAVED_FLAGS = POSITION->DYN->flags;
  memcpy (POSITION->DYN + 1, POSITION->DYN, 64); /* safe with opt ? */
  POSITION->DYN++;
  POSITION->DYN->HASH ^= ZobristWTM;
  POSITION->wtm ^= 1;
  POSITION->height++;
  POSITION->DYN->reversible++;
  if (POSITION->DYN->ep)
    {
      POSITION->DYN->HASH ^= ZobristEP[POSITION->DYN->ep & 7];
      POSITION->DYN->ep = 0;
    }
  POSITION->DYN->Value = -((POSITION->DYN - 1)->Value + TempoValue);
  POSITION->DYN->PositionalValue = (POSITION->DYN - 1)->PositionalValue;
  POSITION->DYN->lazy = (POSITION->DYN - 1)->lazy;
  POSITION->DYN->flags &= ~3;
  POSITION->DYN->move = 0;
  POSITION->STACK[++(POSITION->StackHeight)] = POSITION->DYN->HASH;
  VALIDATE (POSITION, 0, MOVE_NONE);
}

static INLINE void UndoNull (typePOS* POSITION)
{
  TRACE (TRACE_MAKE_UNMAKE,
         printf ("U%cN %d\n", POSITION->wtm ? 'b' : 'w', HEIGHT(POSITION)));
  POSITION->DYN--;
  POSITION->StackHeight--;
  POSITION->height--;
  POSITION->wtm ^= 1;
  POSITION->DYN->flags = POSITION->DYN->SAVED_FLAGS;
  VALIDATE (POSITION, 1, MOVE_NONE);
}

#define NULL_REDUCTION 8
#define VERIFY_REDUCTION 2
